#ifndef BIRCH_SQLITE_HPP
#define BIRCH_SQLITE_HPP

#include "libbirch.hpp"

#include "birch-standard.hpp"
#line 1 "src/SQLite3.birch"

#include <sqlite3.h>
namespace birch {
#line 3 "src/SQLite3.birch"
#line 3 "src/SQLite3.birch"
class SQLite3_;
#line 3 "src/SQLite3.birch"
#line 3 "src/SQLite3.birch"
using SQLite3 = libbirch::Shared<SQLite3_>;
#line 1 "src/SQLite3Statement.birch"
#line 1 "src/SQLite3Statement.birch"
class SQLite3Statement_;
#line 1 "src/SQLite3Statement.birch"
#line 1 "src/SQLite3Statement.birch"
using SQLite3Statement = libbirch::Shared<SQLite3Statement_>;


#line 3 "src/SQLite3.birch"
#line 3 "src/SQLite3.birch"
class SQLite3_ : public Object_ {
public:
  #line 3 "src/SQLite3.birch"
  LIBBIRCH_CLASS(SQLite3_, Object_)
  #line 3 "src/SQLite3.birch"
  LIBBIRCH_CLASS_NO_MEMBERS()
  #line 3 "src/SQLite3.birch"
  using base_type_::operator=;
  
  #line 3 "src/SQLite3.birch"
  SQLite3_();

  #line 9 "src/SQLite3.birch"

  sqlite3* db = nullptr;
    #line 16 "src/SQLite3.birch"
  #line 16 "src/SQLite3.birch"
  virtual void open(const String& filename);
  #line 29 "src/SQLite3.birch"
  #line 29 "src/SQLite3.birch"
  virtual void close();
  #line 42 "src/SQLite3.birch"
  #line 42 "src/SQLite3.birch"
  virtual SQLite3Statement prepare(const String& sql);
  #line 56 "src/SQLite3.birch"
  #line 56 "src/SQLite3.birch"
  virtual void exec(const String& sql);
};

#line 3 "src/SQLite3.birch"
extern "C" SQLite3_* make_SQLite3_();

#line 1 "src/SQLite3Statement.birch"
#line 1 "src/SQLite3Statement.birch"
class SQLite3Statement_ : public Object_ {
public:
  #line 1 "src/SQLite3Statement.birch"
  LIBBIRCH_CLASS(SQLite3Statement_, Object_)
  #line 1 "src/SQLite3Statement.birch"
  LIBBIRCH_CLASS_NO_MEMBERS()
  #line 1 "src/SQLite3Statement.birch"
  using base_type_::operator=;
  
  #line 1 "src/SQLite3Statement.birch"
  SQLite3Statement_();

  #line 5 "src/SQLite3Statement.birch"

  sqlite3_stmt* stmt = nullptr;
    #line 15 "src/SQLite3Statement.birch"
  #line 15 "src/SQLite3Statement.birch"
  virtual void bind(const Integer& i, const Integer& x);
  #line 30 "src/SQLite3Statement.birch"
  #line 30 "src/SQLite3Statement.birch"
  virtual void bind(const Integer& i, const Real& x);
  #line 45 "src/SQLite3Statement.birch"
  #line 45 "src/SQLite3Statement.birch"
  virtual void bind(const Integer& i, const String& x);
  #line 60 "src/SQLite3Statement.birch"
  #line 60 "src/SQLite3Statement.birch"
  virtual void bindNull(const Integer& i);
  #line 83 "src/SQLite3Statement.birch"
  #line 83 "src/SQLite3Statement.birch"
  virtual Boolean step();
  #line 96 "src/SQLite3Statement.birch"
  #line 96 "src/SQLite3Statement.birch"
  virtual Integer columnCount();
  #line 109 "src/SQLite3Statement.birch"
  #line 109 "src/SQLite3Statement.birch"
  virtual std::optional<Integer> columnInteger(const Integer& i);
  #line 125 "src/SQLite3Statement.birch"
  #line 125 "src/SQLite3Statement.birch"
  virtual std::optional<Real> columnReal(const Integer& i);
  #line 141 "src/SQLite3Statement.birch"
  #line 141 "src/SQLite3Statement.birch"
  virtual std::optional<String> columnString(const Integer& i);
  #line 155 "src/SQLite3Statement.birch"
  #line 155 "src/SQLite3Statement.birch"
  virtual Boolean columnNull(const Integer& i);
  #line 164 "src/SQLite3Statement.birch"
  #line 164 "src/SQLite3Statement.birch"
  virtual void reset();
  #line 176 "src/SQLite3Statement.birch"
  #line 176 "src/SQLite3Statement.birch"
  virtual void finalize();
};

#line 1 "src/SQLite3Statement.birch"
extern "C" SQLite3Statement_* make_SQLite3Statement_();

}

#endif
